Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## groovy.lang
[Java] Annotation Type GrabConfig

    java.lang.Object
      groovy.lang.GrabConfig

    @Retention(RetentionPolicy.SOURCE)
    @Target({
            ElementType.CONSTRUCTOR,
            ElementType.FIELD,
            ElementType.LOCAL_VARIABLE,
            ElementType.METHOD,
            ElementType.PARAMETER,
            ElementType.TYPE})
    public @interface GrabConfig

Used to modify the grape configuration for grab requests.

An example involving databases:

     @Grab('mysql:mysql-connector-java:5.1.6'),
     @GrabConfig(systemClassLoader=true)
     import groovy.sql.Sql

     def sql=Sql.newInstance("jdbc:mysql://localhost/test", "user", "password", "com.mysql.jdbc.Driver")
     println sql.firstRow('SELECT * FROM INFORMATION_SCHEMA.COLUMNS')

Another example involving XStream:

     @Grapes([
         @Grab('com.thoughtworks.xstream:xstream:1.3.1'),
         @Grab('xpp3:xpp3_min:1.1.4c'),
         @GrabConfig(systemClassLoader=true, initContextClassLoader=true)
     ])
     import com.thoughtworks.xstream.*

     class Staff {
         String firstname, lastname, position
     }

     def xstream = new XStream()
     def john1 = new Staff(firstname:'John',
                          lastname:'Connor',
                          position:'Resistance Leader')

     // write out to XML file
     new File("john.xml").withOutputStream { out ->
         xstream.toXML(john1, out)
     }

     // now read back in
     def john2
     new File("john.xml").withInputStream { ins ->
         john2 = xstream.fromXML(ins)
     }

     println john2.dump()

Further information about customising grape behavior can be found on the Grape documentation page: http://groovy.codehaus.org/Grape.

Optional Element Summary
`boolean` | `initContextClassLoader` Set to true if you want the context classloader to be initialised to the classloader of the current class or script.
`boolean` | `systemClassLoader` Set to true if you want to use the system classloader when loading the grape.

Method Summary

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Element Detail

### initContextClassLoader

    public boolean initContextClassLoader

  Set to true if you want the context classloader to be initialised to the classloader of the current class or script. This is useful for libraries or frameworks that assume that the context classloader has been set. But be careful when using this flag as your script or class might behave differently when called directly (from the command line or from an IDE) versus when called from within a container, e.g. a web container or a JEE container. @default false

### systemClassLoader

    public boolean systemClassLoader

  Set to true if you want to use the system classloader when loading the grape. This is normally only required when a core Java class needs to reference the grabbed classes, e.g. for a database driver accessed using DriverManager. @default false

Groovy Documentation